Bug 40057 - HSLF: support for TxMasterStyleAtom
Summary: HSLF: support for TxMasterStyleAtom
Status: RESOLVED FIXED
Alias: None
Product: POI
Classification: Unclassified
Component: HSLF (show other bugs)
Version: unspecified
Hardware: Other other
: P2 normal (vote)
Target Milestone: ---
Assignee: POI Developers List
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2006-07-17 14:48 UTC by Yegor Kozlov
Modified: 2007-04-13 23:56 UTC (History)
0 users



Attachments
patch for TxMasterStyleAtom (19.83 KB, patch)
2006-07-17 14:49 UTC, Yegor Kozlov
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Yegor Kozlov 2006-07-17 14:48:38 UTC
A new record TxMasterStyleAtom is implemented. Unit test is included.
Comment 1 Yegor Kozlov 2006-07-17 14:49:22 UTC
Created attachment 18610 [details]
patch for TxMasterStyleAtom
Comment 2 Yegor Kozlov 2006-07-17 14:54:20 UTC
TxMasterStyleAtom stores default (master) character and paragraph styles. 

The doc describing the record structure is to be written. 
As always documenting is the hardest and the most tedious job. :))
Comment 3 Nick Burch 2006-07-18 16:43:04 UTC
Thanks for this, committed

Are the list of TextProp's pretty much the same for StyleTextPropAtom and
TxMasterStyleAtom?

If so, it might be good to keep the list together?
Comment 4 Yegor Kozlov 2006-07-19 11:08:37 UTC
>Are the list of TextProp's pretty much the same for StyleTextPropAtom
>and TxMasterStyleAtom?

The list of properties for TxMasterStyleAtom is very close to what we have for 
StyleTextPropAtom
BUT the bitmasks for the same property can be different.
Example:
  in StyleTextPropAtom font.size is 0x20000
  in TxMasterStyleAtom font.size is 0x80000

It was the hardest part to understand it. I spent a lot of time trying to create
a generic list of properties
which works in both cases. No luck, They are just different!
Looks like in Microsoft TxMasterStyleAtom and StyleTextPropAtom were implemented
by different developers
and they didn't communicate with each other.

>If so, it might be good to keep the list together?
I think we need to move  TextPropCollection out of
StyleTextPropAtom and keep all the stuff in it. What do you think?


Regards,
Yegor
Comment 5 Nick Burch 2006-07-19 11:13:54 UTC
I'm happy to move TextProp/TextPropCollection out, now it's used in two places.
I think it probably still belongs in the record heirachy though.

I guess we should probably keep the lists of TextProps in StyleTextPropAtom /
TxMasterStyleAtom though. It's crazy that they're different....
Comment 6 Yegor Kozlov 2007-04-13 23:56:04 UTC
I'm resolving it.

TxMasterStyleAtom is implememented. 
There will be some refactoring after 3.0 release but that's another story.

Yegor